#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include "event.h"

char *events[EV_MAX + 2] =
  { "SYN", "KEY", "REL", "ABS", "MSC", "SW", NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, "LED", "SND", NULL, "REP", "FF", "PWR",
  "FF_STATUS", NULL
};

char *keys[KEY_MAX + 2] =
  { "RESERVED", "ESC", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0",
  "MINUS", "EQUAL", "BACKSPACE", "TAB", "Q", "W", "E", "R", "T", "Y", "U",
  "I", "O", "P",
  "LEFTBRACE", "RIGHTBRACE", "ENTER", "LEFTCTRL", "A", "S", "D", "F", "G",
  "H", "J", "K", "L",
  "SEMICOLON", "APOSTROPHE", "GRAVE", "LEFTSHIFT", "BACKSLASH", "Z", "X", "C",
  "V", "B", "N", "M",
  "COMMA", "DOT", "SLASH", "RIGHTSHIFT", "KPASTERISK", "LEFTALT", "SPACE",
  "CAPSLOCK", "F1", "F2",
  "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10", "NUMLOCK", "SCROLLLOCK",
  "KP7", "KP8", "KP9",
  "KPMINUS", "KP4", "KP5", "KP6", "KPPLUS", "KP1", "KP2", "KP3", "KP0",
  "KPDOT", NULL,
  "ZENKAKUHANKAKU", "102ND", "F11", "F12", "RO", "KATAKANA", "HIRAGANA",
  "HENKAN",
  "KATAKANAHIRAGANA", "MUHENKAN", "KPJPCOMMA", "KPENTER", "RIGHTCTRL",
  "KPSLASH", "SYSRQ",
  "RIGHTALT", "LINEFEED", "HOME", "UP", "PAGEUP", "LEFT", "RIGHT", "END",
  "DOWN", "PAGEDOWN",
  "INSERT", "DELETE", "MACRO", "MUTE", "VOLUMEDOWN", "VOLUMEUP", "POWER",
  "KPEQUAL", "KPPLUSMINUS",
  "PAUSE", NULL, "KPCOMMA", "HANGEUL", "HANJA", "YEN", "LEFTMETA",
  "RIGHTMETA", "COMPOSE", "STOP",
  "AGAIN", "PROPS", "UNDO", "FRONT", "COPY", "OPEN", "PASTE", "FIND", "CUT",
  "HELP", "MENU", "CALC",
  "SETUP", "SLEEP", "WAKEUP", "FILE", "SENDFILE", "DELETEFILE", "XFER",
  "PROG1", "PROG2", "WWW",
  "MSDOS", "COFFEE", "DIRECTION", "CYCLEWINDOWS", "MAIL", "BOOKMARKS",
  "COMPUTER", "BACK",
  "FORWARD", "CLOSECD", "EJECTCD", "EJECTCLOSECD", "NEXTSONG", "PLAYPAUSE",
  "PREVIOUSSONG",
  "STOPCD", "RECORD", "REWIND", "PHONE", "ISO", "CONFIG", "HOMEPAGE",
  "REFRESH", "EXIT", "MOVE",
  "EDIT", "SCROLLUP", "SCROLLDOWN", "KPLEFTPAREN", "KPRIGHTPAREN", "NEW",
  "REDO", "F13", "F14",
  "F15", "F16", "F17", "F18", "F19", "F20", "F21", "F22", "F23", "F24", NULL,
  NULL, NULL, NULL,
  NULL, "PLAYCD", "PAUSECD", "PROG3", "PROG4", NULL, "SUSPEND", "CLOSE",
  "PLAY", "FASTFORWARD",
  "BASSBOOST", "PRINT", "HP", "CAMERA", "SOUND", "QUESTION", "EMAIL", "CHAT",
  "SEARCH", "CONNECT",
  "FINANCE", "SPORT", "SHOP", "ALTERASE", "CANCEL", "BRIGHTNESSDOWN",
  "BRIGHTNESSUP", "MEDIA",
  "SWITCHVIDEOMODE", "KBDILLUMTOGGLE", "KBDILLUMDOWN", "KBDILLUMUP", "SEND",
  "REPLY", "FORWARDMAIL",
  "SAVE", "DOCUMENTS", "BATTERY", NULL, NULL, NULL, "UNKNOWN", NULL, NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "OK", "SELECT",
  "GOTO", "CLEAR", "POWER2",
  "OPTION", "INFO", "TIME", "VENDOR", "ARCHIVE", "PROGRAM", "CHANNEL",
  "FAVORITES", "EPG", "PVR",
  "MHP", "LANGUAGE", "TITLE", "SUBTITLE", "ANGLE", "ZOOM", "MODE", "KEYBOARD",
  "SCREEN", "PC", "TV",
  "TV2", "VCR", "VCR2", "SAT", "SAT2", "CD", "TAPE", "RADIO", "TUNER",
  "PLAYER", "TEXT", "DVD",
  "AUX", "MP3", "AUDIO", "VIDEO", "DIRECTORY", "LIST", "MEMO", "CALENDAR",
  "RED", "GREEN", "YELLOW",
  "BLUE", "CHANNELUP", "CHANNELDOWN", "FIRST", "LAST", "AB", "NEXT",
  "RESTART", "SLOW", "SHUFFLE",
  "BREAK", "PREVIOUS", "DIGITS", "TEEN", "TWEN", NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "DEL_EOL", "DEL_EOS",
  "INS_LINE", "DEL_LINE",
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  "FN", "FN_ESC", "FN_F1",
  "FN_F2", "FN_F3", "FN_F4", "FN_F5", "FN_F6", "FN_F7", "FN_F8", "FN_F9",
  "FN_F10", "FN_F11",
  "FN_F12", "FN_1", "FN_2", "FN_D", "FN_E", "FN_F", "FN_S", "FN_B", NULL,
  NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, "BRL_DOT1", "BRL_DOT2",
  "BRL_DOT3", "BRL_DOT4",
  "BRL_DOT5", "BRL_DOT6", "BRL_DOT7", "BRL_DOT8", NULL
};
char *relatives[REL_MAX + 2] =
  { "X", "Y", "Z", "RX", "RY", "RZ", "HWHEEL", "DIAL", "WHEEL", "MISC",
  NULL
};

#define BITS_PER_LONG (sizeof(long) * 8)
#define OFF(x)  ((x)%BITS_PER_LONG)
#define LONG(x) ((x)/BITS_PER_LONG)
#define test_bit(bit, array)    ((array[LONG(bit)] >> OFF(bit)) & 1)

static int event_fd;

int event_init (char *basedir, int num)
{
  char tmpstr[255] = "";

  sprintf (tmpstr, "%s/event%d", basedir, num);

  if ((event_fd = open (tmpstr, O_RDONLY | O_NONBLOCK)) < 0)
    return 1;

  return 0;
}

int event_info ()
{
  int version = 0;
  unsigned short id[4];
  int i;
  char name[256] = "Unknown";
  char phys[256] = "Unknown";
  char uniq[256] = "Unknown";
  unsigned long bit[EV_MAX][NBITS (KEY_MAX)];

  if (ioctl (event_fd, EVIOCGVERSION, &version))
   {
     perror ("can't get version");
     return 1;
   }

  printf ("Input driver version is %d.%d.%d\n",
          version >> 16, (version >> 8) & 0xff, version & 0xff);

  ioctl (event_fd, EVIOCGID, id);
  printf ("Input device ID: bus 0x%x vendor 0x%x product 0x%x version 0x%x\n",
          id[ID_BUS], id[ID_VENDOR], id[ID_PRODUCT], id[ID_VERSION]);

  if (ioctl (event_fd, EVIOCGNAME (sizeof (name)), name) >= 0)
    printf ("Input device name: \"%s\"\n", name);
  else
    printf ("No name.\n");

  if (ioctl (event_fd, EVIOCGUNIQ (sizeof (uniq)), uniq) >= 0)
    printf ("Input device uniq: \"%s\"\n", uniq);
  else
    printf ("No uniq.\n");

  if (ioctl (event_fd, EVIOCGPHYS (sizeof (phys)), phys) >= 0)
    printf ("Input device phys: \"%s\"\n", phys);
  else
    printf ("No phys.\n");

  memset (bit, 0, sizeof (bit));
  ioctl (event_fd, EVIOCGBIT (0, EV_MAX), bit[0]);
  printf ("Supported events:\n");

  for (i = 0; i < EV_MAX; i++)
    if (test_bit (i, bit[0]))
     {
       printf ("  Event type %d (%s)\n", i, events[i] ? events[i] : "?");
     }
  return 0;
}

int event_get (struct input_event *ev, int count,int tout)
{
  int rd = 0;
  struct timeval timeout;
  fd_set select_set;
  
  FD_ZERO(&select_set);
  FD_SET(event_fd,&select_set);
  
timeout.tv_sec= 0;
timeout.tv_usec = tout * 1000; /* ms */
  if(select(event_fd+1,&select_set,NULL,NULL,&timeout)<=0) return -2;

  rd = read (event_fd, ev, sizeof (struct input_event) * count);

  if (rd < (int) sizeof (struct input_event))
    return -1;

  return (rd / sizeof (struct input_event));
}

void event_close ()
{

/* disable grabbing mode */
  event_grab (0);
  close (event_fd);
}

int event_grab (int on)
{
  return (ioctl (event_fd, EVIOCGRAB, on));

}

int event_scan (char *basedir, int start, int end)
{
  int i = 0;
  unsigned long bit[EV_MAX][NBITS (KEY_MAX)];

  for (i = start; i <= end; i++)
   {
     if (!event_init (basedir, i))
      {
        ioctl (event_fd, EVIOCGBIT (0, EV_MAX), bit[0]);
        if (test_bit (1, bit[0]) && test_bit (17, bit[0]))
         {
           event_close ();
           return i;
         }
        else
          event_close ();
      }

   }

  return -1;

}
